import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Main {
  public static void main(String[] args) {
    Tuple<Integer,String> t = new Tuple<>(42,"42");

//    System.out.println(t.fst());

    List<Integer> list = new ArrayList<>();
    List<Cat> cats = new ArrayList<>();
    List<Dog> dogs = new ArrayList<>();

    for (int i = 0; i < 10; i++) {
      list.add(i);
      cats.add(new Cat());
      dogs.add(new Dog(""));
    }

//    System.out.println(Lists.zip(list, cats));

    Either<String,Integer> i = div(4,2);

//    System.out.println(i);

    AddOne addOne = new AddOne();

    Function<Integer,Integer> addTwo = addOne.compose(addOne);

//    System.out.println(list);
//    System.out.println(Lists.map(x -> x + 42, list));
//    System.out.println(Lists.filter(x -> x % 2 == 0, list));


    Map<String,Dog> dogMap = new Map<>();

    dogMap.insert("vovve", new Dog("boxer"));
    dogMap.insert("lassie", new Dog("schäfer"));

    dogMap.remove("lassie");

    System.out.println(dogMap.lookup("vovve"));

    for (Tuple<String,Dog> dogTuple : dogMap)
      System.out.println(dogTuple);

  }

  static class AddOne implements Function<Integer,Integer> {
    @Override
    public Integer apply(Integer x) {
      return x + 1;
    }
  }

  public static Either<String,Integer> div(Integer x, Integer y) {
    if (y == 0)
      return Either.left("Division by zero!!!");
    else
      return Either.right(x/y);
  }
}
